/*  DelayUs(x)	Delay specified number of microseconds
    DelayMs(x)	Delay specified number of milliseconds
 x must not exceed 255 - for xtal frequencies > 12MHz the 
 range for DelayUs is even smaller.
    MAKE SURE this code is compiled with full optimization!!!
    "-O -Zg1" option (-Zg3)   */

#define	XTAL_FREQ	4MHZ		/* Crystal frequency in MHz */

#define	MHZ	*1000L		/* number of kHz in a MHz */
#define	KHZ	*1			/* number of kHz in a kHz */

#if	XTAL_FREQ >= 12MHZ
#define	DelayUs(x)	{ unsigned char _dcnt; \
			  _dcnt = (x)*((XTAL_FREQ)/(12MHZ)); \
			  while(--_dcnt != 0) \
				  continue; }
#else
#define	DelayUs(x)	{ unsigned char _dcnt; \
			  _dcnt = (x)/((12MHZ)/(XTAL_FREQ))|1; \
			  while(--_dcnt != 0) \
				  continue; }
#endif
	
void DelayMs(unsigned char cnt){
#if	XTAL_FREQ <= 2MHZ
	do {
		DelayUs(996);
	} while(--cnt);
#endif
#if    XTAL_FREQ > 2MHZ	
	unsigned char	i;
	do {
		i = 4;
		do {
			DelayUs(250);
		} while(--i);
	} while(--cnt);
#endif
}
