//  ..  2005.
// a_biv @ list . ru    
#include <pic.h> // PIC12F675
#include "delay_a.h"
__CONFIG(INTIO & WDTDIS & PWRTEN & BOREN & MCLRDIS & UNPROTECT);
///////////  /////////////////////
bit	PinU	    @ (unsigned)&GPIO*8+0 ; // .
bit	PinR	    @ (unsigned)&GPIO*8+1 ; // .
bit	Buzer       @ (unsigned)&GPIO*8+2 ; // .
bit	Key	    @ (unsigned)&GPIO*8+3 ; //   .
bit	Clock       @ (unsigned)&GPIO*8+4 ; //   .
bit	Data        @ (unsigned)&GPIO*8+5 ; //   .
volatile bit FlagRes;  //   
volatile bit ResOver;  //    
volatile unsigned int U_Val; //  .
volatile unsigned char Over_mS; //  TMR0 
const unsigned char Segment[] = { //  
 //   AFB.GCED          0 - 
    0b00011000,   // 0.
    0b11011011,   // 1.
    0b01010100,   // 2.
    0b01010010,   // 3.
    0b10010011,   // 4.
    0b00110010,   // 5.
    0b00110000,   // 6.
    0b01011011,   // 7.
    0b00010000,   // 8.
    0b00010010,   // 9.
    0b11111111,   // 10 -  .
    0b00010101};  // 11 -  .
//*************************************************************************
/////////////////      /////////////////////////
void Indik_Out(unsigned char Symbol) { //   - 
    unsigned char r;
    Clock = 0;
    for (r=0; r<8; r++){
        Data = Symbol & 0b00000001;
        Symbol = Symbol >> 1;
        Clock = 1;
        DelayUs(10);
        Clock = 0;
        DelayUs(10);
    }
}
/////////////////  ////////////////////////////
// . ( -1024-(512)-[~512V - A365V - 3.3V]).
//  . ( -1024-4096-[8_mA, 409.6_Ohm - 3.3V]).
void Measure(void){
    unsigned char i, c[5]; //   BIN -> BCD
    unsigned char Seg ;  
    unsigned int U_Adc = 0;
    //  
    ADCON0 &= 0b11110011;  //  0.
    TMR1IF = 0; TMR1L = 0; TMR1H = 0xB5; //  -   19.
    TMR1ON = 1; //  start
    U_Val = 0;
    FlagRes = 1; //   -   
    while (TMR1IF == 0 ) {
        GODONE = 1; while(GODONE){ } //   
        U_Adc = (ADRESH << 8) | ADRESL;
        if (U_Adc > 20) { // 10V 
            FlagRes = 0; //   - 
            TMR1IF = 1; //   
        }else{
            DelayMs(1); //      50 
        }
    }
    //  ...
    if (FlagRes == 0) { // ...  
        TMR1IF = 0; TMR1L = 0; TMR1H = 0x9C; //  -   25.
        TMR1ON = 1; //  start    25 
        while ((COUT == 0)&&(TMR1IF == 0)) { } //   + 
        DelayUs(150);
        while ((COUT == 1)&&(TMR1IF == 0)) { } //  - 
        DelayMs(3); //    X  
        GODONE = 1; while(GODONE){ } //   
        U_Val = (ADRESH << 8) | ADRESL;
//      U_Val = U_Val >> 1; //   /2  R3  
        ResOver = 0;
    }else{              // ...  
        ADCON0 |= 0b00000100;  //   1.
        DelayMs(2); //     
        GODONE = 1; while(GODONE){ } //   
        U_Val = (ADRESH << 8) | ADRESL;
        if (U_Val > 752 ){
            ResOver = 1; //  ( 300 )
        }else{
            U_Val = U_Val << 2; //   - 409.6 
            U_Val = U_Val / 10; //   
            ResOver = 0;
        }
    }
    U_Adc = U_Val;
    // 
    if (ResOver == 0){
        for (i=4; i>=1; i--){ //   BCD (c[0]-, c[4]-)
    		c[i] = U_Adc % 10;
    		U_Adc = U_Adc / 10;
    	}
      	if (c[2]==0){ //   00
    		c[2] = 10 ; //  
    		if (c[3]==0) c[3] = 10; //    0
    	}
    }else{
        c[2] = 0; // 
        c[3] = 6; //    "~"
        c[4] = 11;
    }
    Seg = Segment[c[4]]; //   
    if (FlagRes ==1) Seg &= 0b11101111; //  
    Indik_Out(Seg); //   
    Seg = Segment[c[3]]; //   
    Indik_Out(Seg); // 
    Seg = Segment[c[2]]; //    ()
    Indik_Out(Seg); // 
}
/////////////////  ////////////////////////////
void interrupt TMR0_65mS(void) {
	TMR0 = 0;
	Over_mS++;
	if ((Over_mS & 0b00000011) == 0) Measure(); // 260 mS 
	T0IF = 0;
}
/////////////////   ////////////////////////
void main(void){
    di(); CLRWDT();
    INTCON = PIE1 = 0;  //    
    IOCB = 0; //    
    PEIE = 1;   //  
    TRISIO = 0b00001011; GPIO = 0b00000000;
    ANSEL  = 0b00010011;  // Osc/8, GP0,1 - AN0,1
    Clock = 0; Data = 1; //  
    for (Over_mS=0; Over_mS<25; Over_mS++){
        Clock = 1;
        DelayUs(10);
        Clock = 0;
        DelayUs(10);
    }
    ADCON0 = 0b10000001;  // ADC ON, AN0
    CMCON = 0b00000100; // AN1, Vref, non Invert
    VRCON = 0b10100111;  // 1V ref, [(U=xxxx/24)*Vcc]
    OSCCAL = _READ_OSCCAL_DATA(); //  . 
    OPTION = 0b11000111; //  .,  .
    WPU = 0; //  .
    TMR0 = 100; // 4MHz/4/256/256 = 65535   1 = 256 
    T1CON = 0b00000000; //  - 4MHz/4/1/65536 = 65536 mks. Off.
    PIR1 = 0; INTCON &= 0b11111000; //   
    T0IE = 1;
    ei(); //  .   -------------------------------------
    T0IF = 1; //    
    while(1){  //  
        if ((FlagRes ==1)&&(U_Val < 20)){ // ,   
            Buzer = 1;
            DelayUs(250);
            DelayUs(100);
            Buzer = 0;
            DelayUs(250);
            DelayUs(100);
        }
    }
} //**********************************************************************
